 #) Automatically import data
 #IT IS TAILORED FOR A PARTICULAR FORMAT FUSION, single alleles (for Y) registered only ones
 #ASSUME GIVEN FORMAT FOR REFS AND MIXES (identifies based on having peak heights or not)
 importData = function(ff) {
   #The loci names are already predefined in this function: The order matter!
   ln <- c("AMEL","D3S1358","D1S1656","D2S441","D10S1248","D13S317","Penta E","D16S539","D18S51","D2S1338","CSF1PO","Penta D","TH01","vWA","D21S11","D7S820","D5S818","TPOX","D8S1179","D12S391","D19S433","SE33","D22S1045","DYS391","FGA","DYS576","DYS570") 
   #getKit("Fusion 6C","Marker") #eqivalent with this

   X = tableReader(ff) #read file
   cn <- colnames(X) #get column names
   
   #get column indices
   lind = grep("marker",tolower(cn),fixed=TRUE) #locus col-ind
   if(length(lind)==0) lind = grep("loc",tolower(cn),fixed=TRUE) #try another name
   sind = grep("sample",tolower(cn),fixed=TRUE) #sample col-ind
   if(length(sind)>1)  sind = sind[grep("name",tolower(cn[sind]),fixed=TRUE)] #use only sample name
   A_ind = grep("allele",tolower(cn),fixed=TRUE) #allele col-ind
   H_ind = grep("height",tolower(cn),fixed=TRUE) #height col-ind
   sn = unique(as.character(X[,sind])) #sample names

   isstain <- length(H_ind)>0
   #IMPORT REFERENCE PROFILES
   bigmat <- numeric()
   for(s in sn) { #for each ID
    for(loc in ln) { #for each locus
     newline <- c(s, loc)
     xind = X[,sind]==s & toupper(X[,lind])==toupper(loc) #get index in X for given sample and locus
     if(!any(xind)) {
       newline <- c(newline,"")
       if(isstain) newline <- c(newline,"")
     } else {
       av <- as.character(X[xind,A_ind]) #get allele vector
       av <- av[av!="NA" & av!=""]
       newline <- c(newline,paste0(av,collapse="/")) #collapse alleles
       if(isstain) {
        hv <-  as.character(X[xind,H_ind]) #get height vector
        hv <- hv[hv!="NA"]
        newline <- c(newline,paste0(hv,collapse="/")) #collapse peak heights
       }
     }
     bigmat <- rbind(bigmat , newline ) #add new line
   } #end for each loci
  } #end for each sample

  bigref <- bigevid<- numeric()
  if(isstain) {
    bigevid <- bigmat 
    colnames(bigevid) <- c("SampleName","Markers","Alleles","Heights")
  } else {
    bigref <- bigmat 
    colnames(bigref) <- c("SampleName","Markers","Alleles")
  }
  return(list(mix=bigevid,ref=bigref,markers=ln))
}
